<template>
  <div class="app-container">
    <div class="box">
      <div class="box-left">
        <Titlename title="检查项树"></Titlename>
        <div class='box-left-content'>
          <el-tree
            ref="tree"
            :data="tree"
            node-key="value"
            @check="treeClick"
            :expand-on-click-node="false"
            :default-checked-keys="treeList"
            show-checkbox
          ></el-tree>
        </div>
      </div>
      <div class="box-right" v-if="lists == '' ? false : true">
        <div class="btns">
          <el-button type="primary" class="btn" @click="open(1)"
            >添加</el-button
          >
          <el-button type="primary" class="btn" @click="open(0)"
            >暂存</el-button
          >
        </div>
        <div v-for="(item, i) in lists" :key="i" style="padding:0 0 20px 0">
          <div class="title">
            一级要素：<span>{{ item.elementAName }}</span>
          </div>
          <div v-for="(item, index) in item.child" :key="index">
            <el-row class="titles">
              <el-col :span="6" :offset="1"
                ><p><span>二级要素：</span>{{ item.elementBName }}</p></el-col
              >
              <!-- <el-col :span="6" :offset="4"
                ><p><span>得分：</span>50</p></el-col
              > -->
            </el-row>
            <el-row>
              <el-col :span="22" :offset="1">
                <el-table ref="table" border :stripe="true" :data="item.child" :header-cell-style="{background:'#eef1f6',color:'#606266'}" :cell-style="{background:'#fff',color:'#606266'}">
                  <el-table-column
                    prop="standardizationRequirements"
                    align="center"
                    label="排查内容"
                  >
                  </el-table-column>
                  <el-table-column
                    prop="enterpriseStandard"
                    align="center"
                    label="排查依据"
                  ></el-table-column>
                  <el-table-column
                    prop="reviewMethod"
                    align="center"
                    label="排查方法"
                  ></el-table-column>
                  <el-table-column prop="name" align="center" label="评审标准">
                    <el-table-column
                      prop="veto"
                      align="center"
                      label="否决项"
                    ></el-table-column>
                    <el-table-column
                      align="center"
                      width="80px"
                      label="扣分项"
                      type="expand"
                    >
                      <template slot-scope="scope">
                        <el-table border :data="scope.row.deductionList"
                        :header-cell-style="{background:'#eef1f6',color:'#606266'}" :cell-style="{background:'#fff',color:'#606266'}"
                        >
                          <el-table-column
                            prop="name"
                            align="center"
                            label="扣分项"
                          >
                          </el-table-column>
                          <el-table-column
                            prop="remark"
                            align="center"
                            label="扣分备注"
                          >
                          </el-table-column>
                        </el-table>
                      </template>
                    </el-table-column>
                  </el-table-column>
                  <el-table-column align="center" label="操作" width="200px">
                    <template slot-scope="scope">
                      <el-button
                        @click="handleClick(scope.row)"
                        type="text"
                        size="small"
                        >修改</el-button
                      >
                      <!-- <el-button type="text" size="small" style="color: red"
                          >删除</el-button
                        > -->
                    </template>
                  </el-table-column>
                </el-table>
              </el-col>
            </el-row>
          </div>
        </div>
      </div>
    </div>
    <el-dialog :title="id" :visible.sync="dialogVisible" :close-on-click-modal="false" width="30%" custom-class="addInfo">
      <el-form ref="form"  :rules="rules" :model="form" label-width="110px">
        <el-form-item label="排查清单名称" prop="inspectionName">
          <el-input v-model="form.inspectionName" placeholder="企业名称+月份+检查任务名称 "></el-input>
        </el-form-item>
          <div class="valueSelect">
        <el-form-item label="检查人名称" prop="inspector">
          <el-select
            v-model="form.inspector"
            :popper-append-to-body="false"
            filterable
            style="width: 100%"
            placeholder="请选择"
            @change="getCompany"
          >
            <el-option v-for="item in nameList" :key="item.id" :label="item.realname" :value="item.id">
                <div class="valueTable">
                    <div><div>姓名：</div><span>{{item.realname}}</span></div>
                    <div><div>单位：</div><span>{{item.company}}</span></div>
                </div>
            </el-option>
          </el-select>
        </el-form-item>
          </div>
        <el-form-item label="时间" prop="inspectionTime">
          <el-col :span="11">
            <el-date-picker
              type="date"
              value-format="yyyy-MM-dd"
              placeholder="开始时间"
              v-model="form.inspectionTime"
              style="width: 100%"
            ></el-date-picker>
          </el-col>
          <!-- <el-col style="text-align:center" :span="2">-</el-col>
    <el-col :span="11">
      <el-date-picker type="date"  format="yyyy 年 MM 月 dd 日" placeholder="结束时间" v-model="form.inspectionEndTime" style="width: 100%;"></el-date-picker>
    </el-col> -->
        </el-form-item>
      <el-form-item label="被检查单位" prop="checkedCompanyId">
          <el-select
              v-model="form.checkedCompanyId"
              filterable
              style="width: 100%"
              placeholder="请选择"
              :disabled="isCompany"
          >
              <el-option
                  v-for="item in companyList"
                  :key="item.id"
                  :label="item.company"
                  :value="item.id"
              >
              </el-option>
          </el-select>
      </el-form-item>
      </el-form>
      <span
        slot="footer"
        style="text-align: center; display: block"
        class="dialog-footer"
      >
        <el-button type="primary" class="btn" @click="addC">确 定</el-button>
        <el-button @click="closeDialog">取 消</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
import Titlename from "../../components/Titlename/index.vue";
import {
  safetyInspectionItemTreeA,
  safetyInspectionItemTreeB,
  safetySelfInspectionAdd,
  safetyInspectionItemName,
  safetySelfInspectionInfo,
  safetySelfInspectionMod,
    getCompany
} from "@/api/safetySelfInspection.js";
export default {
  components: { Titlename },
  data() {
    return {
      dialogVisible: false,
      show: true,
      form: {
        inspectionName: "",
        inspector: "",
        inspectionTime: "",
        status: "",
        itemList: [],
        checkedCompanyId: null,
        checkedCompanyName: ''
      },
      formInline: {
        user: "",
        region: "",
      },
      list: [],
      lists: [],
      nameList: [],
      companyList: [],
      isCompany: false,
      tree: [],
      id: "",
      elementAName: "",
      arr: [],
      treeList: [],
      defaultProps: {
        children: "children",
        label: "label",
      },
      itemId: "",
       parent: [],
        rules: {
            inspectionName: [{required: true, message: '排查清单名称不能为空', trigger: 'blur'}],
            inspector: [{required: true, message: '检查人名称为空', trigger: 'blur'}],
            inspectionTime: [{required: true, message: '检查时间不能为空', trigger: 'blur'}],
            checkedCompanyId: [{required: true, message: '被检查单位不能为空', trigger: 'blur'}]
        },
    };
  },
  created() {
    this.TreeA();
      safetyInspectionItemName().then((res) => {
        if (res.data.code == 200) {
          this.nameList = res.data.result;
        }
      });
    this.id = this.$route.query.name;
    this.itemId = this.$route.query.id;
    // this.itemInfo(this.itemId);
      this.getCompanyList()
  },
  methods: {
    itemInfo(id) {
      safetySelfInspectionInfo({ id: id }).then((res) => {
        if (res.data.code == 200) {
          this.form = res.data.result;
          this.list = res.data.result;
          var trees = [];
          for (var i = 0; i < this.list.itemList.length; i++) {
            trees.push(this.list.itemList[i].elementA);
          }
          this.treeList = Array.from(new Set(trees));
          var arr = this.checkSameDataA(this.list.itemList);
          for (var i = 0; i < arr.length; i++) {
            var cser=[]
              for(var j=0;j<arr[i].child.length;j++){
             var capB = {
                safetySelfInspectionId: "",
                safetyInspectionItemId: "",
              }
              arr[i].child[j].deductionList= arr[i].child[j].selfDeductionList
              capB.safetySelfInspectionId=arr[i].child[j].safetySelfInspectionId
              capB.safetyInspectionItemId=arr[i].child[j].safetyInspectionItemId
              cser.push(capB)
              }
              arr[i].id=cser
            arr[i].child = this.checkSameData(arr[i].child);
          }
          this.lists = arr;
        }
      });
    },
      async getCompanyList(){
        const res = await getCompany()
          if (res.data.code == 200) {
              this.companyList = res.data.result;
          }
      },
      getCompany(val){
        const t = this
        const obj = t.nameList.find(item => item.id === val)
        if(obj.roleid == 35){
            t.form.checkedCompanyId = obj.companyid
            t.form.checkedCompanyName = obj.company
            t.isCompany = true
        }else{
            t.form.checkedCompanyId = null
            t.form.checkedCompanyName = ''
            t.isCompany = false
        }
      },
    TreeA() {
      safetyInspectionItemTreeA().then((res) => {
        if (res.data.code == 200) {
          this.tree = res.data.result;
        }
      });
    },
    TreeB(id) {
      safetyInspectionItemTreeB({ id: id }).then((res) => {
        // this.list = [];
        if (this.id == "添加") {
          if (res.data.code == 200) {
            this.list = res.data.result;
            var capA = { elementAName: "", id: [], child: [] };
            var atte = [];
            capA.elementAName = this.list[0].elementAName;
            for (var i = 0; i < this.list.length; i++) {
              var capB = {
                safetySelfInspectionId: "",
                safetyInspectionItemId: "",
              };
              capB.safetyInspectionItemId = this.list[i].id;
              atte.push(capB);
            }
            capA.id = atte;
            capA.child = this.checkSameData(this.list);
            if (
              this.lists.findIndex(
                (item) => item.elementAName === capA.elementAName
              ) == -1
            ) {
              this.lists.push(capA);
            } else {
              var i = this.lists.findIndex(
                (item) => item.elementAName === capA.elementAName
              );
              this.lists.splice(i, 1);
            }
          }
        } else if (this.id == "编辑") {
          this.list = res.data.result;
          if(this.list.length!=0){
          var capA = { elementAName: "", id: [], child: [] };
          var atte = [];

          capA.elementAName = this.list[0].elementAName;
          for (var i = 0; i < this.list.length; i++) {
               var capB = {
              safetySelfInspectionId: "",
              safetyInspectionItemId: "",
            };
            capB.safetyInspectionItemId = this.list[i].id;
            capB.safetySelfInspectionId = this.itemId;
            atte.push(capB);
          }
          capA.id = atte;
          capA.child = this.checkSameData(this.list);
          if (
            this.lists.findIndex(
              (item) => item.elementAName === capA.elementAName
            ) == -1
          ) {
            this.lists.push(capA);
          } else {
            var i = this.lists.findIndex(
              (item) => item.elementAName === capA.elementAName
            );
            this.lists.splice(i, 1);
          }
        }
        }
      });
    },
    checkSameDataA(resData) {
      let dataInfo = {};
      resData.forEach((item, index) => {
        let { elementAName } = item;
        if (!dataInfo[elementAName]) {
          dataInfo[elementAName] = {
            elementAName,
            id: {},
            child: [],
          };
        }
        dataInfo[elementAName].child.push(item);
      });
      let list = Object.values(dataInfo); // list 转换成功的数据
      return list;
    },
    checkSameData(resData) {
      let dataInfo = {};
      resData.forEach((item, index) => {
        let { elementBName } = item;
        if (!dataInfo[elementBName]) {
          dataInfo[elementBName] = {
            elementBName,
            child: [],
          };
        }
        dataInfo[elementBName].child.push(item);
      });
      let list = Object.values(dataInfo); // list 转换成功的数据
      return list;
    },
    treeClick(currentObj) {
        // console.log(this.$refs.tree.getCheckedNodes().filter(i=>i.type === 1).map(obj=>obj.value))
      this.TreeB(currentObj.value);
    },
    handleClick(data) {
      if (data.safetyInspectionItemId != undefined) {
        this.$router.push({
          path: "/reviewXG",
          query: {
            idX: data.safetyInspectionItemId,
            name:this.id,
            id:this.itemId
          },
        });
      } else {
        this.$router.push({
          path: "/reviewXG",
          query: {
            idX: data.id,
            name:this.id,
            id:this.itemId
          },
        });
      }
    },
    open(type) {
      this.dialogVisible = true;
      this.form.status = type;
      var arr = [];
      for (var i = 0; i < this.lists.length; i++) {
        // this.lists[i].id;
        for (var j = 0; j < this.lists[i].id.length; j++) {
          arr.push(this.lists[i].id[j]);
        }
      }
      this.form.itemList = arr;
    },
      closeDialog(){
        this.dialogVisible = false
      },
    addC() {
       this.$refs["form"].validate((valid) => {
        if (valid) {
      if (this.id == "添加") {
          if(this.form.checkedCompanyId){
              this.form.checkedCompanyName = this.companyList.find(i=>i.id == this.form.checkedCompanyId).company
          }
        safetySelfInspectionAdd(this.form).then((res) => {
          if (res.data.code == 200) {
            this.dialogVisible = false;
            this.$notify({
              type: "success",
              duration: 2000,
              message: "新增成功",
              title: "成功",
            });
            this.$router.push({
              path:"/safetyproduction/safetyproduction/checklistself"
            });
          }
        });
      } else if (this.id == "编辑") {
          if(this.form.checkedCompanyId){
              this.form.checkedCompanyName = this.companyList.find(i=>i.id == this.form.checkedCompanyId).company
          }
        safetySelfInspectionMod(this.form).then((res) => {
          this.dialogVisible = false;
          this.$notify({
            type: "success",
            duration: 2000,
            message: "编辑成功",
            title: "成功",
          });
        });
         this.$router.push({
              path:"/safetyproduction/safetyproduction/checklistself"
            });
      }
         }
      });
    },
    btnsQX() {
      this.show = true;
    },
  },
};
</script>
<style lang='scss' scoped>
.app-container {
  padding: 0px;
}
.box {
  width: 100%;
  display: flex;
  justify-content: space-between;
  background-color: rgb(223, 229, 235);
}
.box-left {
    width: 20%;
    min-width: 220px;
    height:100vh;
    overflow:auto;
    background-color: white;
    border-radius: 5px;
    padding-left: 10px;
}
.box-left-content {
    padding: 10px;
    /deep/.el-tree{
        .el-tree-node{
            white-space: normal !important;
            padding: 4px 0;
        }
    }
}
.box-right {
  position: relative;
  width: 79%;
  background-color: white;
  border-radius: 5px;
  height: 850px;
  overflow-y:overlay;
}
.title {
  font-size: 16px;
  padding: 10px 20px;
  font-weight: bold;
}
.titles {
  font-size: 14px;
}
.btns {
  position: absolute;
  top: 10px;
  right: 50px;
}

.box-left-content /deep/ .el-tree-node__expand-icon {
  display: none;
}

.btn {
  background-color: #034ea2;
  border: 1px solid #034ea2;
}
.box-right /deep/ .el-table__expanded-cell{
  background-color: #fff !important;

}

.el-select{
    /deep/.el-popper{
        .el-select-dropdown__item{
            width: 100%;
            height: auto;
            white-space: normal;
            word-break: break-all;
            word-wrap: break-word;
            overflow: auto;
            padding: 10px 25px;
            border-bottom: 1px solid #ccc;

            .valueTable{
                &>div{
                    line-height: 1.5;
                    margin-bottom: 6px;
                    display: flex;
                    align-items: center;

                    div{
                        color: #999;
                    }

                    span{
                        font-weight: bolder;
                    }

                    &:last-of-type{
                        margin-bottom: 0;
                    }
                }
            }
        }
    }
    /deep/.el-input__inner {
        background-color: #fff;
        color: #606266;
    }
}
</style>
